"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.waitTillHTMLRendered = exports.TEXT_FRAGMENT_REGEX = void 0;
// This regex is used to get the various text components inside a text fragment
const TEXT_CONTENT = "A-Za-z0-9%!#$'()*+/:;=?@[\\]-_.~"; // All allowed URL encoded characters EXCEPT & and ,
// text=[prefix-,]textStart[,textEnd][,-suffix]
exports.TEXT_FRAGMENT_REGEX = new RegExp(`&?text=([${TEXT_CONTENT}]*\-)?,?([${TEXT_CONTENT}]*),?([${TEXT_CONTENT}]*)?,?(\-[${TEXT_CONTENT}]*)?`, 'gi');
const waitTillHTMLRendered = (page) => __awaiter(void 0, void 0, void 0, function* () {
    const timeoutMs = 30000;
    const checkDurationMs = 1000;
    const maxChecks = timeoutMs / checkDurationMs;
    const minStableSizeIterations = 2;
    let lastHTMLSize = 0;
    let checkCounts = 1;
    let countStableSizeIterations = 0;
    while (checkCounts++ <= maxChecks) {
        let html = yield page.content();
        let currentHTMLSize = html.length;
        if (lastHTMLSize != 0 && currentHTMLSize == lastHTMLSize)
            countStableSizeIterations++;
        else
            countStableSizeIterations = 0; //reset the counter
        if (countStableSizeIterations >= minStableSizeIterations)
            break;
        lastHTMLSize = currentHTMLSize;
        yield page.waitForTimeout(checkDurationMs);
    }
});
exports.waitTillHTMLRendered = waitTillHTMLRendered;
